<?php
/*************************************************************************************/
/*                                                                                   */
/*      Benjamin ARGOUD - Decanet.fr                                          		 */
/*                                                                                   */
/*      Copyright (c) Decanet					                                     */
/*		email : benjamin@decanet.fr		        	                             	 */
/*      web : http://www.decanet.fr						   							 */
/*                                                                                   */
/*      This program is free software; you can redistribute it and/or modify         */
/*      it under the terms of the GNU General Public License as published by         */
/*      the Free Software Foundation; either version 2 of the License, or            */
/*      (at your option) any later version.                                          */
/*                                                                                   */
/*      This program is distributed in the hope that it will be useful,              */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                */
/*      GNU General Public License for more details.                                 */
/*                                                                                   */
/*      You should have received a copy of the GNU General Public License            */
/*      along with this program; if not, write to the Free Software                  */
/*      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    */
/*                                                                                   */
/*************************************************************************************/
?>
<?php

	include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsClassiques.class.php");

	class Decanetsms extends PluginsClassiques{
	
		
		function Decanetsms(){
			$this->PluginsClassiques("decanetsms");
		}

		function init(){
			$this->activateShop();
		}			
		
		function destroy(){
		}
		
		private function sendRequest($donnees) {
			$config = $this->getConfig();
			$url = (intval($config['ssl'])==1)?'https':'http';
			$url.='://www.decanet.fr/api/sms.php';	
			foreach($donnees as $key=>$value) { $donnees_ctn .= $key.'='.$value.'&'; }
			rtrim($donnees_ctn,'&');
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch,CURLOPT_POST,count($donnees));
			curl_setopt($ch,CURLOPT_POSTFIELDS,$donnees_ctn);
			$data=curl_exec($ch);
			curl_close($ch);
			return json_decode($data);
		}
	
		private function activateShop() {
			require_once __DIR__ . "/../../classes/Variable.class.php";
			$var = new Variable('urlsite');
			$this->sendRequest(array('thelia'=>$var->valeur));
		}
		
		public function sendMessage($to,$message) {
			$conf = $this->getConfig();
			
			if(substr($to,0,1)=='0')
				$to = "33".substr($to, 1);
			$message = urldecode($message);
			
			$donnees = array(
				'textencoded'=>$message,
				'recipient'=>$to,
				'sendername'=>$conf['expediteur'],
				'messagetruncationallowed'=>'1',
				'action'=>'send',
				'login'=>$conf['login'],
				'pass'=>$conf['pass']
				);
				
			$result = $this->sendRequest($donnees);
			if(isset($result->error)) {
				$this->_html= "<div class='erreur_crea_client'>".$result->error.'</div>';
			} else {
				$this->_html= "<div style='float:right;color:green'>".$result->message.'</div>';
			}
			return $this->_html;
		}	
			
		public function getInfos() {
			$config = $this->getConfig();
			$data = array(
				'action'	=>	'status',
				'login'	=>	$config['login'],
				'pass'	=>	$config['pass'],
			);
			$result = $this->sendRequest($data);
			return $result;
		}
		
		
		public function getConfig() {
			$decaconfig=array();
			include(dirname(__FILE__).'/config/config.php');
			return $decaconfig;
		}
		
		public function setConfig($config) {
			$fp = @fopen(dirname(__FILE__).'/config/config.php','w');
			$ctn = '<?php '."\n";
			$ctn.= '$decaconfig = array('."\n";
			foreach($config as $k=>$v)
				$ctn.= '\''.addslashes($k).'\' => \''.str_replace("'",'\'',$v).'\','."\n";
			$ctn.=');'."\n";
			fwrite($fp, $ctn);
			fclose($fp);
		}
		
		function statut($commande){	  
			$config = $this->getConfig();
			$config['statut'] = json_decode($config['statut']);
			
			$client = new Client($commande->client);
			 
			if(preg_match('#0[67][0-9]{8}#',$client->telport) && $config['statut']->{$commande->statut}->actif=="1" && strlen($config['statut']->{$commande->statut}->message)>5) {			
				 $this->sendMessage($client->telport,$config['statut']->{$commande->statut}->message);
			}
			 
		}

     }
?>
